##############################
#                            #
# Ansible / Tower managed on #
#                            #
##############################

global
    log /dev/log local0
    log /dev/log local1 notice
    chroot /var/lib/haproxy
    stats socket /run/haproxy/admin.sock mode 660 level admin expose-fd listeners
    stats timeout 30s
    user {{ install_haproxy.system_user }}
    group {{ install_haproxy.system_group }}
    daemon
    tune.bufsize 16384000
    # Default SSL material locations
    #ca-base /etc/ssl/certs
    #crt-base /etc/ssl/private
    # Default ciphers to use on SSL-enabled listening sockets.
    # For more information, see ciphers(1SSL). This list is from:
    #  https://hynek.me/articles/hardening-your-web-servers-ssl-ciphers/
    # An alternative list with additional directives can be obtained from
    #  https://mozilla.github.io/server-side-tls/ssl-config-generator/?server=haproxy
    ssl-default-bind-ciphers ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256
    ssl-default-bind-options ssl-min-ver TLSv1.2 no-tls-tickets

defaults
    log {{ install_haproxy.log }}
    #
{% for option in install_haproxy.options %}
    option {{ option }}
{% endfor %}
    #
    timeout connect {{ install_haproxy.timeout_connect }}
    timeout client {{ install_haproxy.timeout_client }}
    timeout server {{ install_haproxy.timeout_server }}
    #
{% for errorfile in install_haproxy__error_files %}
    errorfile {{ errorfile }} {{ install_haproxy.error_path }}/{{ errorfile }}.http
{% endfor %}

{% if install_haproxy__listen_stats.enabled | default(false) %}
listen stats
    mode http
    bind "{{ install_haproxy__listen_stats.bind }}:{{ install_haproxy__listen_stats.port }}" ssl crt {{ install_haproxy__listen_stats.fullchain }}
    http-request redirect scheme https unless { ssl_fc }
    stats enable
    stats uri {{ install_haproxy__listen_stats.uri }}
    stats refresh {{ install_haproxy__listen_stats.refresh }}
{% endif %}
